From 6e48a3586603c3227fbc08c1102985208b839d59 Mon Sep 17 00:00:00 2001
From: Ruben Smits <ruben.smits@intermodalics.eu>
Date: Sat, 11 Feb 2012 21:36:52 +0100
Subject: [PATCH] doc/rtt_cheat_sheet: fix typo in addOperation of class
 member function syntax

Signed-off-by: Ruben Smits <ruben.smits@intermodalics.eu>
---
 doc/rtt_cheat_sheet.svg |   49 +++++++++++++++++++++++++---------------------
 1 files changed, 27 insertions(+), 22 deletions(-)

diff --git a/doc/rtt_cheat_sheet.svg b/doc/rtt_cheat_sheet.svg
index 4e884e6..e757538 100644
--- a/doc/rtt_cheat_sheet.svg
+++ b/doc/rtt_cheat_sheet.svg
@@ -14,7 +14,7 @@
    height="744.09448"
    id="svg2"
    version="1.1"
-   inkscape:version="0.47 r22583"
+   inkscape:version="0.48.2 r9819"
    sodipodi:docname="rtt_cheat_sheet.svg">
   <sodipodi:namedview
      id="base"
@@ -23,16 +23,16 @@
      borderopacity="1.0"
      inkscape:pageopacity="1"
      inkscape:pageshadow="2"
-     inkscape:zoom="1.04"
-     inkscape:cx="680.42843"
-     inkscape:cy="396.2135"
+     inkscape:zoom="2.08"
+     inkscape:cx="124.21761"
+     inkscape:cy="200.01543"
      inkscape:document-units="px"
      inkscape:current-layer="layer1"
      showgrid="false"
-     inkscape:window-width="1920"
-     inkscape:window-height="1126"
-     inkscape:window-x="1680"
-     inkscape:window-y="25"
+     inkscape:window-width="1436"
+     inkscape:window-height="848"
+     inkscape:window-x="0"
+     inkscape:window-y="1024"
      inkscape:window-maximized="1"
      showguides="true"
      inkscape:guide-bbox="true"
@@ -2060,69 +2060,74 @@
              y="716.04102"
              x="261.58096"
              sodipodi:role="line"
-             id="tspan7619">                      &amp;MyComp::checkFoo)</tspan><tspan
+             id="tspan7619">                      &amp;MyComp::checkFoo,</tspan><tspan
              style="font-size:10.3039999px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:94.99999881%;writing-mode:lr-tb;text-anchor:start;fill:#0737e3;fill-opacity:1;font-family:ProggyTinyTT"
              y="725.82983"
              x="261.58096"
              sodipodi:role="line"
+             id="tspan3515">                      this)</tspan><tspan
+             style="font-size:10.3039999px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:94.99999881%;writing-mode:lr-tb;text-anchor:start;fill:#0737e3;fill-opacity:1;font-family:ProggyTinyTT"
+             y="735.61865"
+             x="261.58096"
+             sodipodi:role="line"
              id="tspan7621">                      .doc(&quot;...&quot;).arg(&quot;arg&quot;,&quot;...&quot;);</tspan><tspan
              id="tspan7359-3"
              style="font-size:10.3039999px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:94.99999881%;writing-mode:lr-tb;text-anchor:start;fill:#0737e3;fill-opacity:1;font-family:ProggyTinyTT"
-             y="735.61865"
+             y="745.40747"
              x="261.58096"
              sodipodi:role="line" /><tspan
              id="tspan7391-9"
              style="font-size:10.3039999px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:94.99999881%;writing-mode:lr-tb;text-anchor:start;fill:#0737e3;fill-opacity:1;font-family:ProggyTinyTT"
-             y="745.40747"
+             y="755.19623"
              x="261.58096"
              sodipodi:role="line">// Add C function:</tspan><tspan
              style="font-size:10.3039999px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:94.99999881%;writing-mode:lr-tb;text-anchor:start;fill:#0737e3;fill-opacity:1;font-family:ProggyTinyTT"
-             y="755.19623"
+             y="764.98505"
              x="261.58096"
              sodipodi:role="line"
              id="tspan7758">addOperation(&quot;cFoo&quot;,</tspan><tspan
              style="font-size:10.3039999px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:94.99999881%;writing-mode:lr-tb;text-anchor:start;fill:#0737e3;fill-opacity:1;font-family:ProggyTinyTT"
-             y="764.98505"
+             y="774.77386"
              x="261.58096"
              sodipodi:role="line"
              id="tspan7760">                      &amp;cFoo)</tspan><tspan
              style="font-size:10.3039999px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:94.99999881%;writing-mode:lr-tb;text-anchor:start;fill:#0737e3;fill-opacity:1;font-family:ProggyTinyTT"
-             y="774.77386"
+             y="784.56262"
              x="261.58096"
              sodipodi:role="line"
              id="tspan7762">                      .doc(&quot;...&quot;).arg(&quot;arg&quot;,&quot;...&quot;);</tspan><tspan
              style="font-size:10.3039999px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:94.99999881%;writing-mode:lr-tb;text-anchor:start;fill:#0737e3;fill-opacity:1;font-family:ProggyTinyTT"
-             y="784.56262"
+             y="794.35144"
              x="261.58096"
              sodipodi:role="line"
              id="tspan7764" /><tspan
              style="font-size:10.3039999px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:94.99999881%;writing-mode:lr-tb;text-anchor:start;fill:#0737e3;fill-opacity:1;font-family:ProggyTinyTT"
-             y="794.35144"
+             y="804.14026"
              x="261.58096"
              sodipodi:role="line"
              id="tspan7766">// Execute in own thread:</tspan><tspan
              style="font-size:10.3039999px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:94.99999881%;writing-mode:lr-tb;text-anchor:start;fill:#0737e3;fill-opacity:1;font-family:ProggyTinyTT"
-             y="804.14026"
+             y="813.92902"
              x="261.58096"
              sodipodi:role="line"
              id="tspan7774">addOperation(&quot;checkFoo&quot;,</tspan><tspan
              style="font-size:10.3039999px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:94.99999881%;writing-mode:lr-tb;text-anchor:start;fill:#0737e3;fill-opacity:1;font-family:ProggyTinyTT"
-             y="813.92902"
+             y="823.71783"
              x="261.58096"
              sodipodi:role="line"
              id="tspan7768">                      &amp;MyComp::checkFoo,</tspan><tspan
              style="font-size:10.3039999px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:94.99999881%;writing-mode:lr-tb;text-anchor:start;fill:#0737e3;fill-opacity:1;font-family:ProggyTinyTT"
-             y="823.71783"
+             y="833.50665"
              x="261.58096"
              sodipodi:role="line"
-             id="tspan7776">                      OwnThread)</tspan><tspan
+             id="tspan7776">                      this, OwnThread)</tspan><tspan
              style="font-size:10.3039999px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:94.99999881%;writing-mode:lr-tb;text-anchor:start;fill:#0737e3;fill-opacity:1;font-family:ProggyTinyTT"
-             y="833.50665"
+             y="843.29547"
              x="261.58096"
              sodipodi:role="line"
              id="tspan7770">                      .doc(&quot;...&quot;).arg(&quot;arg&quot;,&quot;...&quot;);</tspan><tspan
              style="font-size:10.3039999px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:94.99999881%;writing-mode:lr-tb;text-anchor:start;fill:#0737e3;fill-opacity:1;font-family:ProggyTinyTT"
-             y="843.29547"
+             y="853.08423"
              x="261.58096"
              sodipodi:role="line"
              id="tspan7772" /></text>
-- 
1.7.5.4